---
- entityDefinitions:
  - IDE_UserList: '{ceccad4f-a1c2-4945-831a-a34ee2c502ea}'
  - IDBEM_UserList: '{0c202bb4-6afb-4f34-8a29-55723dc61ae1}'
  - IDBEMP_UserList: '{ca4361b5-c336-4c6d-8f44-95487879fca4}'
  
  - IDM_User__get__All_Users_on_This_Tenant: '{7415d0de-ec70-4542-8885-f4c6319f08a8}'
  - IDMB_User__get__All_Users_on_This_Tenant: '{6e734b70-c4ae-4a5b-b870-5019f2b4eef1}'

- library: '&IDL_MochaBaseSystem;'
  instances:
  - getInstancesMethod: '&IDM_User__get__All_Users_on_This_Tenant;'
    moduleId: '&IDI_Module_MochaBaseSystem_OOP_OOPMethodExamples;'
    forClassId: '&IDC_User;'
    accessModifierId: '&IDI_AccessModifier_RootA2;'
    verb: 'get'
    name: 'All Users on This Tenant'
    static: yes
    final: no
    returnsWorkSetId: '&IDI_WorkSet_UserNonsingular;'
    selectsInstancesOfClass: '&IDC_User;'

  - returnInstanceSetMethodBinding: '&IDMB_User__get__All_Users_on_This_Tenant;'
    executesMethod: '&IDM_User__get__All_Users_on_This_Tenant;'

  - buildElementMethod: '&IDBEM_UserList;'
    hasBemProcess: '&IDBEMP_UserList;'

  - bemProcess: '&IDBEMP_UserList;'
    name: 'build user list'
    loopExecutableReturningInstanceSet: '&IDMB_User__get__All_Users_on_This_Tenant;' # the GI, above

  - element: '&IDE_UserList;'
    name: user list
    index: 113789
    processedByPRUMethod: null
    elementContents:
    - globalIdentifier: '{ce9eff84-034f-49ab-a976-adff7c402f00}'
      order: 'a'
      label: 'User'
      defaultDataType: '&IDC_User;'
      # builtFromBEMProcess: '&IDBEM_1;'
    - globalIdentifier: '{f24ec140-7f6c-4efc-920d-076352f257ae}'
      order: 'b'
      label: 'User Name'
      defaultDataType: '&IDA_UserName;'
      # builtFromBEMProcess: '&IDBEM_1;'
    - globalIdentifier: '{da51a173-0838-4936-87e0-ec4eebbb4275}'
      order: 'c'
      label: 'Preferred Display Name'
      defaultDataType: '&IDMB_User__get__Preferred_Display_Name;'
      # builtFromBEMProcess: '&IDBEM_1;'
    - globalIdentifier: '{82b0a709-eedc-4af2-9ffa-b91648b6e53f}'
      order: 'd'
      label: 'Nonce'
      defaultDataType: '&IDA_PasswordSalt;'
      # builtFromBEMProcess: '&IDBEM_1;'
      displayOptions:
      - instance: '&IDI_DisplayOption_DoNotShow;'
    - globalIdentifier: '{52dadfbd-79d7-409b-9b3e-710c13a7aefc}'
      order: 'e'
      label: 'SHA-512 Hash'
      defaultDataType: '&IDA_PasswordHash;'
      # builtFromBEMProcess: '&IDBEM_1;'
      displayOptions:
      - instance: '&IDI_DisplayOption_DoNotShow;'